/* ---------------- SIGNAL CATCING ------------------ */
//#ifndef CATCHSIG
//#define CATCHSIG

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <signal.h>

static void ex_program(int sig) {
  if(sig==SIGINT) {
    printf("\n [INFO] Caught Signal Nr. %d (SIGINT).\n",sig);
    printf(" [INFO] Run will be halted after the next iteration.\n");
    csignal=sig;
    (void) signal(SIGINT, SIG_DFL); 
  } else if(sig==SIGTERM) {
    printf("\n [INFO] Caught Signal Nr. %d (SIGTERM).\n",sig);
    printf(" [INFO] Run will be halted immediatly.\n");
    csignal=sig;
    (void) signal(SIGTERM, SIG_DFL); 
  } else if(sig==SIGXCPU) {
    printf("\n [INFO] Caught Signal Nr. %d (SIGXCPU).\n",sig);
    printf(" [INFO] Run will be halted immediatly.\n");
    csignal=sig;
    (void) signal(SIGXCPU, SIG_DFL);
  } else if(sig==SIGUSR2) {
    printf("\n [INFO] Caught Signal Nr. %d (SIGUSR2).\n",sig);
    printf(" [INFO] Run will be halted immediatly.\n");
    csignal=sig;
    (void) signal(SIGUSR2, SIG_DFL);
  } 
}

//#endif

/* ---------------------------------------------------------------- */
