#include "TMVAnalysis_MLP.class.h"
#include <vector>

extern "C" void getval_(double* a, double* values){

  std::vector<std::string> myInputs;
  myInputs.push_back("pthard");
  myInputs.push_back("ptsoft");
  myInputs.push_back("mll");
  myInputs.push_back("met");
  myInputs.push_back("phill");

  ReadMLP myMLP(myInputs);

  std::vector<double> myVals;

  for(int j=0; j<5; ++j) {
    myVals.push_back(*values);
    (values)++;
  }
  
  (*a)=myMLP.GetMvaValue(myVals);

}
