CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   meggppp.f

      double complex function meggppp(s12,s13,s23,mh,m,bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      doublecomplex t1
      doublecomplex t100
      doublecomplex t11
      doublecomplex t115
      doublecomplex t119
      doublecomplex t127
      doublecomplex t13
      doublecomplex t14
      doublecomplex t15
      doublecomplex t17
      doublecomplex t2
      doublecomplex t22
      doublecomplex t23
      doublecomplex t24
      doublecomplex t26
      doublecomplex t3
      doublecomplex t30
      doublecomplex t32
      doublecomplex t34
      doublecomplex t37
      doublecomplex t38
      doublecomplex t40
      doublecomplex t42
      doublecomplex t44
      doublecomplex t46
      doublecomplex t51
      doublecomplex t57
      doublecomplex t58
      doublecomplex t60
      doublecomplex t63
      doublecomplex t67
      doublecomplex t7
      doublecomplex t76
      doublecomplex t79
      doublecomplex t82
      doublecomplex t91
      doublecomplex t96


      double precision ss,tt,uu

      double complex meggpppLim
      external meggpppLim
      
      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      ttrian(one)=r12*trian(one)
      ttrian(two)=r13*trian(two)
      ttrian(three)=r23*trian(three)
      ttrian(four)=tmh2*trian(four)
      ttriana(one)=(ttrian(four)-ttrian(one))
      ttriana(two)=(ttrian(four)-ttrian(two))
      ttriana(three)=(ttrian(four)-ttrian(three))
      bboxx(one)=r12*r13*boxx(one)
      bboxx(two)=r12*r23*boxx(two)
      bboxx(three)=r23*r13*boxx(three)
      

      pf=-4d0*tm2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)

      if (s12.gt.0d0) then
         ss=s12
         tt=s13
         uu=s23
      elseif (s13.gt.0d0) then
         ss=s13
         tt=s12
         uu=s23
      else
         ss=s23
         tt=s12
         uu=s13
      endif


      if ((dabs(tt)/ss.lt.10d-6).or.(dabs(uu)/ss.lt.10d-6)) then
         meggppp=meggpppLim(s12,s13,s23,mh,m,bub,trian,boxx)
      else
        t1 = r13*r23
        t2 = 1/r12
        t3 = ttrian(two)
        t7 = ttrian(three)
        t11 = 2*r12
        t13 = r23+r12
        t14 = t13**2
        t15 = 1/t14
        t17 = bub(two)
        t22 = r13+r12
        t23 = t22**2
        t24 = 1/t23
        t26 = bub(three)
        t30 = r13**2
        t32 = r12*t30
        t34 = r13*r12
        t37 = r12**2
        t38 = t37*r13
        t40 = r23**2
        t42 = t37*r23
        t44 = t37*r12
        t46 = r12*t40
        t51 = bub(four)
        t57 = 2*tm2-r12/2
        t58 = bboxx(one)
        t60 = bboxx(two)
        t63 = tm2*r12
        t67 = bboxx(three)
        t76 = ttriana(one)
        t79 = t37**2
        t82 = 2*t38*r23
        t91 = 4*t44*tm2
        t96 = 1/t13
        t100 = ttriana(two)
        t115 = 1/t22
        t119 = ttriana(three)
        t127 = 2*t1*t2*t3+2*t1*t2*t7+4*t1*(t11+r23)*t15*t17+4*t1*(t11+r1
     #3)*t24*t26-4*t1*(t30*r23+2*t32+4*t34*r23+5*t38+r13*t40+5*t42+4*t44
     #+2*t46)*t24*t15*t51+t57*t58+t57*t60-(4*t1+12*t63-t37)*t2*t67/2+(4*
     #tm2-r12)*(r23+r13)/(tmh2-r12)*t76+(-t79+t37*t40-t82-4*t34*t40-2*t4
     #0*r23*r13-8*t42*tm2+t91-4*t46*tm2)*t2*t96/(tmh2-r13)*t100-(4*t32*r
     #23+t82-t37*t30+t79+2*r23*t30*r13+4*t63*t30-t91+8*t38*tm2)*t2*t115/
     #(tmh2-r23)*t119-4*(-t37+t1)*r12*t96*t115
        meggppp = pf*t127
      endif


      return
      end

      double complex function meggpppLim(s12,s13,s23,mh,m,
     $     bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      double precision ss,tt,uu

      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)

      meggpppLim=-2d0*tm2**2*(2d0/tmh2
     $     +(4d0*tm2/tmh2-1d0)*trian(four))
C         meggpppLim=-2d0/3d0*tm2
      meggpppLim=meggpppLim*dcmplx(0d0,1d0)/tm2*r12**2*4d0
      meggpppLim=meggpppLim/sqrt(abs(s12*s13*s23))



      return
      end






