CCCCCC model.f
C
C     masses
      double precision mh,mt,mb,mZ,mW
      double precision mh2,mt2,mb2,mZ2,mW2
      double precision ms1,ms2,msb1,msb2
      double precision ms12,ms22,msb12,msb22
      common/MASSES/mh,mt,mb,mZ,mW,ms1,ms2,msb1,msb2,
     $  mh2,mt2,mb2,mZ2,mW2,ms12,ms22,msb12,msb22 
C
      double precision GammaH,GammaW,GammaZ
      common/WIDTHS/GammaH,GammaW,GammaZ

C     model parameters
      double precision GF,sw2,alpha,beta,ths,thsb,mu

      common/MODPARA/GF,sw2,alpha,beta,ths,thsb,mu
C
C     couplings
      double precision relt(2),relb(2)
      double precision ytth,ybbh
      double precision yssh(2,2),ysbsbh(2,2)
        
      common/COUPLINGS/ytth,ybbh,yssh,ysbsbh,
     &   relt,relb

      double precision gvzu,gvzd,gazu,gazd,ghww,ghzz,gvw,gaw
      common/WCOUPLINGS/gvzu,gvzd,gazu,gazd,ghww,ghzz,gvw,gaw

C
C     Higgs      
      integer htype
      common/higgs/htype

      integer imbscheme
      common/mbrenscheme/imbscheme
