      subroutine hggtot_INTE2(ndim,vars,ncomp,risc)
      implicit none
      INTEGER ndim,ncomp,jj,isetval, ival, Ngrids
      double precision vars(ndim), risc(ncomp)
      double precision Rplus, Rdelta, Rreg
      double precision xorki

C      common /Ngrids/ Ngrids
      include 'pdfcontrol.f'
      double precision tres1(1),tres2(3*(NSMax+1))
      
c$$$      vars(1)=1.25973611201352625d-02
c$$$      vars(2)=2.31682843516106988d-03
c$$$
c$$$      write(6,*)'INTE2: ',ndim,ncomp
c$$$      write(6,*)'XXX    ',vars
      if (ncomp.eq.1) then 

         call matrixelem(ndim,vars,2,2,2,1,tres1)
         risc(1)=tres1(1)

      else
         call matrixelem(ndim,vars,2,2,0,NPDFerrorNNLO+1,tres2)
         do jj=1,3*(NPDFerrorNNLO+1)
            if (jj.gt.ncomp) then
               write(6,*)'counter>ncomp: ',jj,ncomp,NPDFerrorNNLO+1
               stop
            endif
            risc(jj)=tres2(jj)
C            write(6,*)'tres2(',jj,')= ',tres2(jj),ncomp
         enddo
      endif
C      do jj=1,ncomp
C         write(6,*)'risc(',jj,')= ',risc(jj)
C      enddo

      return
      end


      subroutine hggtot_INTE1(ndim,vars,ncomp,risc)
      implicit none
      INTEGER ndim,ncomp,jj,isetval, ival, Ngrids
      double precision vars(ndim), risc(ncomp)
      double precision Rplus, Rdelta, Rreg
      double precision xorki

C      common /Ngrids/ Ngrids
      include 'pdfcontrol.f'
      double precision tres1(1),tres2(3*(NSMax+1))

        
      if (ncomp.eq.1) then 

         call matrixelem(ndim,vars,1,1,1,1,tres1)
         risc(1)=tres1(1)

      else
C         write(6,*)'INTE1: '
C         write(6,*)tres2
         call matrixelem(ndim,vars,1,1,0,NPDFerrorNLO+1,tres2)
         do jj=1,2*(NPDFerrorNLO+1)
            if (jj.gt.ncomp) then
               write(6,*)'counter>ncomp: ',jj,ncomp,NPDFerrorNLO+1
               stop
            endif
            risc(jj)=tres2(jj)
C            write(6,*)'tres2(',jj,')= ',tres2(jj),ncomp
         enddo
      endif
      return
      end      


      subroutine hggtot_INTE0(ndim,vars,ncomp,risc)
      implicit none
      INTEGER ndim,ncomp,jj,isetval, ival, Ngrids
      double precision vars(ndim), risc(ncomp)
      double precision Rplus, Rdelta, Rreg
      double precision xorki

C      common /Ngrids/ Ngrids
      include 'pdfcontrol.f'
      double precision tres1(1),tres2(3*(NSMax+1))
 
      if (ncomp.eq.1) then 

         call matrixelem(ndim,vars,0,0,0,1,tres1)
         risc(1)=tres1(1)

      else
         call matrixelem(ndim,vars,0,0,0,NPDFerrorLO+1,tres2)
         do jj=1,(NPDFerrorLO+1)
            if (jj.gt.ncomp) then
               write(6,*)'counter>ncomp: ',jj,ncomp,NPDFerrorLO+1
               stop
            endif
            risc(jj)=tres2(jj)
C            write(6,*)'tres2(',jj,')= ',tres2(jj),ncomp
         enddo
      endif
      return
      end



      subroutine givevalerr(Nmax, ris, cval, pluse, minuse)
      implicit none 
      integer Nmax, jj
      double precision ris(1:Nmax)
      double precision cval, pluse, minuse 
      double precision tmp

      cval=ris(1)
      pluse=0d0
      minuse=0d0

      do jj=1,Nmax
         if (ris(jj).ne.0d0) then 
            tmp=ris(jj)-ris(1)
            if (tmp.gt.0d0) then 
               pluse = pluse+tmp**2
            elseif (tmp.lt.0d0) then
               minuse = minuse+tmp**2
            endif
         endif
      enddo

      pluse=dsqrt(pluse)/cval*100d0
      minuse=dsqrt(minuse)/cval*100d0
      end
