      subroutine h0_couplings(flavor,mq,ms1,ms2,th,alpha,beta,mZ,
     &                            sw2,mu,hf,hs)
      character*3 flavor
      double precision mq,ms1,ms2,th,alpha,beta,mZ,sw2,mu,hf,hs(2,2)
      double precision ca,sa,cb,sb,ms12,ms22,mZ2,mq2,sth2,cth2,sth,cth
      double precision hLL,hRR,hLR
      
      ca=cos(alpha)
      sa=sin(alpha)
      cb=cos(beta)
      sb=sin(beta)
      ms12=ms1**2
      ms22=ms2**2
      mq2=mq**2
      mZ2=mZ**2
      cth=cos(th)
      sth=sin(th)
      sth2=sth**2
      cth2=cth**2

c$$$      write(6,*)flavor
c$$$      write(6,*)mq/173.4d0,ms1/173.4d0,ms2/173.4d0,th,alpha,beta,
c$$$     $     mZ/173.4d0,sw2,mu

      if(flavor.EQ.'TOP') then
         hf=ca/sb
         hLL=2*ca/sb+mZ2/mq2*(4*sw2-3)/3.d0*(sa*cb+ca*sb)
         hRR=2*ca/sb-mZ2/mq2*(4*sw2)/3.d0*(sa*cb+ca*sb)
         hLR=ca/sb*(ms12-ms22)/mq2/2*sin(2*th)+mu/mq*(ca*cb/sb**2+sa/sb)
      elseif(flavor.EQ.'BOT') then
         hf=-sa/cb
         hLL=-2*sa/cb+mZ2/mq2*(3-2*sw2)/3.d0*(sa*cb+ca*sb)
         hRR=-2*sa/cb+mZ2/mq2*(2*sw2)/3.d0*(sa*cb+ca*sb)
         hLR=-sa/cb*(ms12-ms22)/mq2/2*sin(2*th)
     &       -mu/mq*(sa*sb/cb**2+ca/cb)
      elseif(flavor.EQ.'NIL') then
         hf=ca/sb
         hLL=0.d0
         hRR=0.d0
         hLR=0.d0
      endif
c$$$      write(6,*) hf
c$$$
c$$$      write(6,*) hLL,hRR,hLR

      hs(1,1)=hLL*cth2+hRR*sth2+2*hLR*sth*cth
      hs(2,2)=hRR*cth2+hLL*sth2-2*hLR*sth*cth
      hs(1,2)=hLR*(cth2-sth2)+(hRR-hLL)*sth*cth
      hs(2,1)=hs(1,2)

      return
      end
