CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CCC   smeggppp.f
      
      double complex function smeggppp(s12,s13,s23,mh,m,bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      double complex ttrian(1:4)
      double complex bboxx(1:3)
      double complex ttriana(1:3)

      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      doublecomplex t101
      doublecomplex t102
      doublecomplex t104
      doublecomplex t129
      doublecomplex t131
      doublecomplex t139
      doublecomplex t142
      doublecomplex t146
      doublecomplex t154
      doublecomplex t157
      doublecomplex t160
      doublecomplex t167
      doublecomplex t21
      doublecomplex t33
      doublecomplex t38
      doublecomplex t41
      doublecomplex t46
      doublecomplex t47
      doublecomplex t49
      doublecomplex t5
      doublecomplex t50
      doublecomplex t52
      doublecomplex t53
      doublecomplex t56
      doublecomplex t59
      doublecomplex t65
      doublecomplex t7
      doublecomplex t73
      doublecomplex t8
      doublecomplex t80
      doublecomplex t90


      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      ttrian(one)=r12*trian(one)
      ttrian(two)=r13*trian(two)
      ttrian(three)=r23*trian(three)
      ttrian(four)=tmh2*trian(four)
      ttriana(one)=(ttrian(four)-ttrian(one))
      ttriana(two)=(ttrian(four)-ttrian(two))
      ttriana(three)=(ttrian(four)-ttrian(three))
      bboxx(one)=r12*r13*boxx(one)
      bboxx(two)=r12*r23*boxx(two)
      bboxx(three)=r23*r13*boxx(three)
      

      pf=-4d0*tm2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)
      
  
        t5 = r13*r23
        t7 = r13**2
        t8 = r23*t7
        t21 = r12**2
        t33 = r23**2
        t38 = t21*r12
        t41 = t33*r12
        t46 = r13+r12
        t47 = t46**2
        t49 = 1/t47
        t50 = r23+r12
        t52 = t50**2
        t53 = 1/t52
        t56 = bub(four)
        t59 = 2*r12
        t65 = bub(three)
        t73 = bub(two)
        t80 = 2*tm2*t38
        t90 = t5*t21
        t101 = 1/r12
        t102 = 1/t50
        t104 = ttriana(two)
        t129 = 1/t46
        t131 = ttriana(three)
        t139 = ttriana(one)
        t142 = ttrian(two)
        t146 = ttrian(three)
        t154 = bboxx(three)
        t157 = bboxx(two)
        t160 = bboxx(one)
        t167 = t5*(t8+2*t7*r12+4*r23*r12*r13+5*r13*t21+t33*r13+5*r23*t21
     #+4*t38+2*t41)*t49*t53*t56-t5*(r13+t59)*t49*t65-t5*(r23+t59)*t53*t7
     #3+(-t80+2*tm2*t33*r12+2*t41*r13+r13*t33*r23+t90+4*tm2*r23*t21)/(tm
     #h2-r13)*t101*t102*t104/2-(t7*r13*r23+2*t8*r12+t90-t80+2*t7*tm2*r12
     #+4*tm2*r13*t21)/(-tmh2+r23)*t101*t129*t131/2-tm2*(r23+r13)/(tmh2-r
     #12)*t139-t5*t101*t142/2-t5*t101*t146/2+(3*tm2*r12+t5)*t101*t154/2-
     #tm2*t157/2-tm2*t160/2+(t5-t21)*r12*t102*t129
        
        smeggppp = pf*t167
c$$$        write(6,*)'## smeggppp: ',s12,s13,s23,mh,m
c$$$        write(6,*)'##           ',smeggppp
c$$$        write(6,*)'## trian:    ',trian
        return
      end




      double complex function smeggpppold(s12,s23,s13,mh,m,
     $     bub,trian,boxx)
      implicit none
      doubleprecision s12
      doubleprecision s23
      doubleprecision s13
      doubleprecision mh
      doubleprecision m
      double complex bub(1:4)
      double complex trian(1:4)
      double complex boxx(1:3)
      double complex triana(1:3)
      
      double complex r12,r13,r23,tm2,tmh2,pf,tmp
      integer one,two,three,four
      parameter( one=1, two=2, three=3, four=4)

      doublecomplex t1
      doublecomplex t11
      doublecomplex t112
      doublecomplex t113
      doublecomplex t115
      doublecomplex t12
      doublecomplex t123
      doublecomplex t13
      doublecomplex t132
      doublecomplex t137
      doublecomplex t146
      doublecomplex t17
      doublecomplex t18
      doublecomplex t2
      doublecomplex t21
      doublecomplex t22
      doublecomplex t23
      doublecomplex t25
      doublecomplex t3
      doublecomplex t30
      doublecomplex t31
      doublecomplex t32
      doublecomplex t34
      doublecomplex t37
      doublecomplex t39
      doublecomplex t4
      doublecomplex t42
      doublecomplex t43
      doublecomplex t45
      doublecomplex t47
      doublecomplex t49
      doublecomplex t5
      doublecomplex t54
      doublecomplex t58
      doublecomplex t59
      doublecomplex t6
      doublecomplex t60
      doublecomplex t61
      doublecomplex t65
      doublecomplex t7
      doublecomplex t76
      doublecomplex t78
      doublecomplex t82
      doublecomplex t85
      doublecomplex t88
      doublecomplex t89
      doublecomplex t95
      doublecomplex t99

      r12=dcmplx(s12,0d0)
      r13=dcmplx(s13,0d0)
      r23=dcmplx(s23,0d0)
      triana(one)=1d0/(tmh2-r12)*(tmh2*trian(four)-r12*trian(one))
      triana(two)=1d0/(tmh2-r13)*(tmh2*trian(four)-r13*trian(two))
      triana(three)=1d0/(tmh2-r23)*(tmh2*trian(four)-r23*trian(three))
      tm2=dcmplx(m**2,0d0)
      tmh2=dcmplx(mh**2,0d0)
      pf=4d0*tm2*tmh2/zsqrt(r12*r13*r23)*dcmplx(0d0,1d0)

        t1 = r13**2
        t2 = r23*t1
        t3 = 1/r12
        t4 = tmh2
        t5 = 1/t4
        t6 = t5*t3
        t7 = trian(two)
        t11 = r23**2
        t12 = t11*r13
        t13 = trian(three)
        t17 = r13*r23
        t18 = 2*r12
        t21 = r13+r12
        t22 = t21**2
        t23 = 1/t22
        t25 = bub(three)
        t30 = r23+r12
        t31 = t30**2
        t32 = 1/t31
        t34 = bub(two)
        t37 = t1*r12
        t39 = r12*r13
        t42 = r12**2
        t43 = t42*r13
        t45 = t42*r23
        t47 = t42*r12
        t49 = t11*r12
        t54 = bub(four)
        t58 = r12*r23
        t59 = tm2
        t60 = t5*t59
        t61 = boxx(two)
        t65 = boxx(one)
        t76 = boxx(three)
        t78 = triana(one)
        t82 = triana(three)
        t85 = t82*r13
        t88 = triana(two)
        t89 = t88*r23
        t95 = t88*t11
        t99 = t82*t1
        t112 = t78*t2+t78*t37+t78*t43+t42*r23*t82-2*t42*t85-2*t42*t89+t4
     #2*r13*t88+t47*t88-r12*t95+t78*t45+t47*t82-r23*t99-r12*t99-2*t58*t8
     #5-2*t39*t89-r13*t95+t78*t12+t78*t49+2*t78*r23*t39
        t113 = 1/t30
        t115 = 1/t21
        t123 = t82*t1*r13
        t132 = t42**2
        t137 = t88*t11*r23
        t146 = -t47*r13*t89-t42*t1*t89-t58*t123-t11*t123-t42*t11*t85-t47
     #*r23*t85-2*t45*t99+2*t132-2*r23*t43-t1*t137-2*t43*t95-2*t37*t95-t3
     #9*t137-2*t49*t99
        tmp = t7*t6*t2/2+t13*t6*t12/2+t25*t5*t23*(t18+r13)*t17+t34*
     #t5*t32*(t18+r23)*t17-t54*t5*t32*t23*(t2+2*t37+4*r23*t39+5*t43+t12+
     #5*t45+4*t47+2*t49)*t17+t61*t60*t58/2+t65*t60*t39/2+t76*t5*(-3.D0
     #/2.D0*t59*t17-t3*t11*t1/2)+t5*(t59*t115*t113*t112+t115*t113*t3
     #*t146/2)

        smeggpppold = pf*tmp

      return
      end


      
