CCC   smemscalar.f
CCC   scalar matrix elements in the heavy mass limit

C =============================
      function smebornmscalar()
      implicit none
      double precision smebornmscalar
      smebornmscalar=-(1d0/6d0)
      return 
      end

      function smevirtualmscalar()
      implicit none
      double precision smevirtualmscalar
      double precision Nc
      Nc=3d0
      smevirtualmscalar=(9d0/Nc-13d0*Nc)/12d0
      return
      end

C =============================

      double complex function smeggpppmscalar(s,t,u,mh)
      implicit none
      double precision s,t,u,mh
      double precision pf
      double complex stu
      stu=dcmplx(s*t*u,0d0)
C      pf=-1d0/12d0
      pf=-1d0/3d0
      smeggpppmscalar=dcmplx(0d0,pf*s**2)/zsqrt(stu)
      return
      end

      double complex function smeggppmmscalar(s,t,u,mh)
      implicit none
      double precision s,t,u,mh
      double precision pf
      double complex stu
      stu=dcmplx(s*t*u,0d0)
C      pf=-1d0/12d0
      pf=-1d0/3d0
      smeggppmmscalar=dcmplx(0d0,pf*mh**4)/zsqrt(stu)
      return
      end

      double complex function smeqqpmpmscalar(s,t,u,mh)
      implicit none
      double precision s,t,u,mh
      double precision pf
      double complex zs
      zs=dcmplx(s,0d0)
      pf=-dsqrt(2d0)/12d0
      smeqqpmpmscalar=dcmplx(pf*t,0d0)/zsqrt(zs)
      return
      end
