CCC   smevirt.f
CCC   scalar matrix elements for virtual corrections


      subroutine smevirtsp(x,Hr1,Hr2,Hr3,Hr4,Hi1,Hi2,Hi3,Hi4,mer,mei)
      implicit none
      real*8 x
      doubleprecision mer
      doubleprecision mei
      doubleprecision PI
      integer n1,n2
      parameter (n1=-1) 
      parameter (n2=1) 
      real*8     Hr1,Hr2,Hr3,Hr4 
      real*8     Hi1,Hi2,Hi3,Hi4 
      dimension Hr1(n1:n2),Hr2(n1:n2,n1:n2),Hr3(n1:n2,n1:n2,n1:n2), 
     $          Hr4(n1:n2,n1:n2,n1:n2,n1:n2) 
      dimension Hi1(n1:n2),Hi2(n1:n2,n1:n2),Hi3(n1:n2,n1:n2,n1:n2), 
     $          Hi4(n1:n2,n1:n2,n1:n2,n1:n2) 
      parameter (PI=3.14159265358979323846264d0)

      doubleprecision demi1
      doubleprecision t1
      doubleprecision t10
      doubleprecision t100
      doubleprecision t103
      doubleprecision t114
      doubleprecision t116
      doubleprecision t117
      doubleprecision t12
      doubleprecision t122
      doubleprecision t125
      doubleprecision t128
      doubleprecision t129
      doubleprecision t132
      doubleprecision t146
      doubleprecision t148
      doubleprecision t15
      doubleprecision t152
      doubleprecision t155
      doubleprecision t156
      doubleprecision t159
      doubleprecision t162
      doubleprecision t164
      doubleprecision t169
      doubleprecision t175
      doubleprecision t18
      doubleprecision t186
      doubleprecision t189
      doubleprecision t192
      doubleprecision t194
      doubleprecision t197
      doubleprecision t2
      doubleprecision t202
      doubleprecision t203
      doubleprecision t206
      doubleprecision t21
      doubleprecision t213
      doubleprecision t220
      doubleprecision t227
      doubleprecision t230
      doubleprecision t237
      doubleprecision t24
      doubleprecision t249
      doubleprecision t252
      doubleprecision t255
      doubleprecision t258
      doubleprecision t268
      doubleprecision t269
      doubleprecision t27
      doubleprecision t28
      doubleprecision t287
      doubleprecision t290
      doubleprecision t295
      doubleprecision t296
      doubleprecision t297
      doubleprecision t303
      doubleprecision t306
      doubleprecision t31
      doubleprecision t325
      doubleprecision t326
      doubleprecision t336
      doubleprecision t34
      doubleprecision t35
      doubleprecision t359
      doubleprecision t390
      doubleprecision t4
      doubleprecision t40
      doubleprecision t405
      doubleprecision t426
      doubleprecision t43
      doubleprecision t45
      doubleprecision t458
      doubleprecision t48
      doubleprecision t488
      doubleprecision t49
      doubleprecision t5
      doubleprecision t50
      doubleprecision t508
      doubleprecision t511
      doubleprecision t517
      doubleprecision t53
      doubleprecision t541
      doubleprecision t58
      doubleprecision t6
      doubleprecision t63
      doubleprecision t66
      doubleprecision t69
      doubleprecision t8
      doubleprecision t84
      doubleprecision t87
      doubleprecision t89
      doubleprecision t9
      doubleprecision t90
      doubleprecision t93

        t1 = Hi1(0)
        t2 = t1*x
        t4 = Hr1(0)
        t5 = t4*x
        t6 = t1*t5
        t8 = x**2
        t9 = t8*x
        t10 = t1*t9
        t12 = Hr2(0,1)
        t15 = Hr2(0,-1)
        t18 = Hr3(0,0,1)
        t21 = Hr3(0,0,-1)
        t24 = Hr1(1)
        t27 = Hi1(1)
        t28 = t27*t8
        t31 = t24*t4
        t34 = t8*t4
        t35 = t1**2
        t40 = t9*t4
        t43 = t1*t40
        t45 = t27*t1
        t48 = 0.157913670417428D3*t2+0.315827340834859D3*t6+0.1579136704
     #17429D3*t10-0.234666666666667D3*t12*t5+0.853333333333333D2*t15*t5-
     #0.245333333333333D3*t18*t5+0.245333333333333D3*t21*t5-0.1259136704
     #17429D3*t24*t5+0.631654681669718D3*t1*t28+0.189913670417429D3*t9*t
     #31+0.552697846461003D3*t35*t34-0.639999999999999D2*t24*t34+0.10132
     #7938517851D4*t35*t40-0.315827340834859D3*t43-0.187437279737889D4*t
     #9*t45
        t49 = t4**2
        t50 = t49**2
        t53 = Hi2(0,-1)
        t58 = Hi2(0,1)
        t63 = t9*t24
        t66 = x*t49
        t69 = t9*t49
        t84 = t27*x
        t87 = -0.555555555555556D0*t50*x-0.84220624222629D3*t53*t2+0.842
     #20624222629D3*t53*t10+0.23160671661223D4*t58*t2-0.23160671661223D4
     #*t58*t10+0.136858514361773D4*t35*t63+0.328986813369644D2*t35*t66-0
     #.855365714761076D2*t35*t69+0.266666666666667D2*t12*t66+0.122666666
     #666667D3*t12*t69-0.426666666666667D2*t15*t66-0.426666666666667D2*t
     #15*t69+0.138666666666667D3*t24*t66-0.138666666666667D3*t24*t69+0.1
     #24271811570917D4*t1*t84
        t89 = t49*t4
        t90 = x*t89
        t93 = t9*t89
        t100 = Hr3(0,1,-1)
        t103 = Hr3(0,-1,1)
        t114 = x*t24
        t116 = t27*t9
        t117 = t35*t1
        t122 = x*t12
        t125 = t9*t12
        t128 = 0.16D2*t24*t90-16.D0*t24*t93-0.437333333333333D3*t18*t40+
     #0.437333333333333D3*t21*t40-192.D0*t100*t40-192.D0*t103*t40+0.2346
     #66666666667D3*t12*t40-0.853333333333333D2*t15*t40+0.192D3*t103*t5-
     #0.460581538717503D3*t35*t5-0.314192388109962D3*t114-0.155854545654
     #403D4*t117*t116+0.155854545654403D4*t117*t84-0.263189450695716D3*t
     #35*t122-0.12106714732003D4*t35*t125
        t129 = x*t15
        t132 = t9*t15
        t146 = t21*x
        t148 = t8**2
        t152 = t58*t9
        t155 = Hi3(0,0,-1)
        t156 = t155*t9
        t159 = Hi3(0,1,-1)
        t162 = t49*t8
        t164 = 0.421103121113146D3*t35*t129+0.421103121113146D3*t35*t132
     #-0.192D3*t12*t129+192.D0*t12*t132+0.384D3*t21*t114-384.D0*t21*t63-
     #0.136858514361773D4*t35*t114-0.404432980707364D3*x-0.1706666666666
     #67D3*t146-0.733333333333333D2*t148+0.192D3*t100*t5-0.1894964045009
     #15D4*t53*t152+0.378992809001831D4*t27*t156-0.189496404500915D4*t15
     #9*t2-0.32D2*t162
        t169 = Hi3(0,-1,1)
        t175 = Hi3(0,0,1)
        t186 = t58*x
        t189 = t155*x
        t192 = t21*t9
        t194 = t27*t53
        t197 = t1*t4
        t202 = 0.189496404500915D4*t159*t10-0.189496404500915D4*t169*t2+
     #0.189496404500915D4*t169*t10+0.612239041579901D3*t9+0.242134294640
     #058D4*x*t175*t1+0.431630699140973D4*t175*t10-0.242134294640058D4*t
     #155*t2-0.293333333333333D-12*t8-0.431630699140973D4*t155*t10+0.189
     #496404500915D4*t53*t186-0.378992809001831D4*t27*t189+0.17066666666
     #6667D3*t192-0.189496404500915D4*t194*t40-0.52637890139143D3*t186*t
     #197-0.242134294640058D4*t152*t197
        t203 = t53*x
        t206 = t53*t9
        t213 = t18*x
        t220 = t1*t24
        t227 = t35*x
        t230 = t35*t9
        t237 = 0.84220624222629D3*t203*t197+0.84220624222629D3*t206*t197
     #-0.473741011252288D3*t45*t66+0.189496404500915D4*t45*t129+0.256D3*
     #t213-0.273717028723544D4*t45*t5+0.273717028723544D4*t45*t40+0.1579
     #13670417429D3*t122+0.189496404500915D4*t203*t220-0.189496404500915
     #D4*t206*t220+0.189496404500915D4*t194*t5-0.473741011252288D3*t227*
     #t31+0.473741011252288D3*t230*t31-0.192D3*t129*t31+192.D0*t132*t31
        t249 = Hr4(0,0,0,1)
        t252 = Hr4(0,0,0,-1)
        t255 = Hr4(0,-1,0,1)
        t258 = t35**2
        t268 = 0.733333333333331D2-0.16D2*t24+0.451236577926803D3*t227+0
     #.31582734083486D3*t35*t8+0.144444444444444D1*t50*t9+16.D0*t4*t148+
     #0.473741011252288D3*t45*t69+0.48D3*t249*x-0.479999999999999D3*t252
     #*x+0.192D3*t255*x-0.541161616855567D2*t258*x-1056.D0*t252*t9-192.D
     #0*t255*t9+0.140702020382447D3*t258*t9-0.567620782259338D2*t5
        t269 = t18*t9
        t287 = t1*t8
        t290 = -256.D0*t269+672.D0*t249*t9-0.145975078833679D4*t230-0.45
     #7198241782619D2*t66+0.155555555555556D2*t90-0.157913670417429D3*t1
     #25+0.58666666666667D2*t34+16.D0*t24*t148-0.186666666666666D2*t8*t8
     #9-0.342222222222222D2*t93+0.314192388109962D3*t63+0.18724645636517
     #1D3*t40-0.189496404500915D4*t45*t132-0.315827340834858D3*t287+0.14
     #790367769712D3*t69
        t295 = -1+x
        t296 = t295**2
        t297 = t296**2
        demi1 = (1+x)*t297*t295
        mer = -1/demi1*(t48+t87+t128+t164+t202+t237+t268+t290)*x
        t303 = x*t175
        t306 = Hi4(0,0,0,1)
        t325 = -0.160490995161374D4*t2-0.25853951477132D4*t6+0.723822947
     #387088D4*t303+0.529426882554784D4*t10+0.135716802635079D5*t306*x+0
     #.482548631591394D4*t156+0.836375593125928D4*t43-0.241274315795696D
     #4*t197*t129-0.542867210540316D4*t4*t53*t114-0.542867210540316D4*t4
     #*t15*t84+0.542867210540316D4*t10*t15*t24-0.45238934211693D3*x-0.22
     #6194671058465D3*t148+0.45238934211693D3*t9
        t326 = Hi4(0,0,0,-1)
        t336 = t175*t9
        t359 = -0.298576965797174D5*t326*t9+0.753982236861552D3*t49*t186
     #+0.45238934211693D3*t89*t84-0.542867210540316D4*t1*t9*t103-0.12365
     #3086845294D5*t4*t336-0.628318530717959D2*t1*t90+0.163362817986669D
     #3*t1*t93-0.108573442108063D5*t24*t156-0.108573442108063D5*t27*t192
     #-0.386958332970141D5*t35*t84-0.446490384196315D4*t117*t114+0.62012
     #5533605997D3*t117*t5-0.161232638737559D4*t117*t40-0.74415064032719
     #2D4*t35*t186+0.119064102452351D5*t35*t203
        t390 = -0.342309294550508D5*t35*t152+0.119064102452351D5*t35*t20
     #6+0.446490384196315D4*t117*t63+0.386958332970141D5*t35*t116+0.5428
     #67210540316D4*t1*t103*x-0.392070763168006D4*t49*t116+0.10857344210
     #8063D5*t24*t189+0.542867210540316D4*t15*t152-0.542867210540316D4*t
     #15*t186+0.542867210540316D4*t53*t125-0.542867210540316D4*t53*t122-
     #0.120637157897848D4*t49*t203-0.180955736846772D4*t4*t28+0.13194689
     #1450771D4*t1*t66
        t405 = Hi4(0,-1,0,1)
        t426 = 0.542867210540316D4*t1*t100*x-0.180955736846772D4*t1*t24*
     #t8-0.158336269740925D4*t1*t162-0.663504368438166D4*t1*t122-0.69366
     #3657912624D4*t1*t213+0.123653086845294D5*t1*t192+0.542867210540316
     #D4*t405*x+0.241274315795696D4*t4*t203-0.693663657912624D4*t4*t303+
     #0.542867210540316D4*t4*t169*x+0.542867210540316D4*t4*t159*x+0.6936
     #63657912624D4*t4*t189+0.663504368438166D4*t1*t125-0.48254863159139
     #4D4*t189-0.542867210540316D4*t1*t9*t100
        t458 = -0.542867210540316D4*t4*t9*t159+0.542867210540316D4*t40*t
     #15*t27-0.241274315795696D4*t197*t132-0.663504368438166D4*t4*t186-0
     #.123653086845294D5*t1*t269+0.536968252619701D4*t4*t116+0.392070763
     #168006D4*t49*t84-0.45238934211693D3*t27-0.356012515772929D4*t4*t84
     #-0.180955736846772D4*t1*t34+0.693663657912624D4*t1*t146+0.24127431
     #5795696D4*t1*t129+0.108573442108063D5*t27*t146+0.346831828956313D4
     #*t49*t152
        t488 = -0.45238934211693D3*t89*t116-0.120637157897848D4*t49*t206
     #-0.356012515772929D4*t1*t114-0.542867210540316D4*t4*t9*t169-0.2902
     #83161191697D4*t1*t69-0.241274315795696D4*t1*t132+0.663504368438166
     #D4*t4*t152+0.123653086845294D5*t4*t156-0.241274315795696D4*t4*t206
     #+0.536968252619701D4*t1*t63+0.446490384196315D4*t227+0.95499332175
     #3234D4*t117*t9-0.542867210540316D4*t405*t9+0.45238934211693D3*t148
     #*t27-0.446490384196315D4*t152
        t508 = t1*t49
        t511 = 0.226194671058465D3+0.888358048470079D4*t116-0.4523893421
     #1693D3*t5-0.135716802635079D5*t326*x+0.446490384196315D4*t186-0.44
     #6490384196315D4*t230-0.45238934211693D3*t66+0.45238934211693D3*t1*
     #t148-0.723822947387088D4*t336+0.520905448229037D4*t117*t8+0.904778
     #68423386D3*t34+0.542867210540316D4*t40*t53*t24+0.19000352368911D5*
     #t306*t9-0.135716802635079D4*t508*t63
        t517 = t35*t4
        t541 = -0.434087873524197D4*t117*x-0.542867210540316D4*t1*t15*t1
     #14+0.133947115258895D5*t517*t116-0.535788461035579D5*t10*t194-0.45
     #238934211693D3*t40-0.133947115258895D5*t517*t84+0.78414152633601D4
     #*t197*t114+0.535788461035579D5*t1*t53*t84+0.15079644737231D4*t197*
     #t122+0.165876092109541D4*t287-0.78414152633601D4*t197*t63+0.452389
     #34211693D3*t69+0.135716802635079D4*t508*t114+0.693663657912624D4*t
     #197*t125-0.888358048470079D4*t84
        mei = -1/demi1*(t325+t359+t390+t426+t458+t488+t511+t541)*x/9
        return
      end

C =============================
      subroutine smevirtac(theta,acl1,acl2,als1,als2,als3,alsc1,
     #           alsc2,alsc3,alslsc1,alslsc2,alslsc3,mer,mei)
      implicit none
      doubleprecision theta
      doubleprecision mer
      doubleprecision mei
      doubleprecision theta0
      double precision acl1,acl2,als1,als2,als3,alsc1,alsc2,alsc3
      double precision alslsc1,alslsc2,alslsc3
      dimension als1(2:4,0:2),als2(2:4,0:2),als3(2:4,0:2)
      dimension alsc1(2:3,2:3),alsc2(2:3,2:3),alsc3(2:3,2:3)

      doubleprecision t1
      doubleprecision t10
      doubleprecision t103
      doubleprecision t106
      doubleprecision t109
      doubleprecision t114
      doubleprecision t121
      doubleprecision t123
      doubleprecision t13
      doubleprecision t14
      doubleprecision t17
      doubleprecision t2
      doubleprecision t3
      doubleprecision t30
      doubleprecision t32
      doubleprecision t37
      doubleprecision t40
      doubleprecision t45
      doubleprecision t50
      doubleprecision t54
      doubleprecision t57
      doubleprecision t59
      doubleprecision t6
      doubleprecision t63
      doubleprecision t65
      doubleprecision t67
      doubleprecision t72
      doubleprecision t78
      doubleprecision t8
      doubleprecision t92


      theta0 = 0.65d0

      if (theta.lt.theta0) then
         call smevirtacexp(theta,mer,mei)
      else

        t1 = theta/2
        t2 = dcos(t1)
        t3 = t2**2
        t6 = als2(2,0)
        t8 = theta**2
        t10 = dsin(t1)
        t13 = t2*t10
        t14 = theta*t6
        t17 = als1(2,0)
        t30 = 0.906329552679134D2-0.181265910535828D3*t3-0.2571466107372
     #37D2*theta+0.118435252813072D3*t6-0.358333333333333D1*t10*t8*t2+0.
     #533333333333332D1*t14*t13+0.133333333333333D1*t17*theta*t13+0.12D2
     #*t17*t6*t13+0.866666666666666D1*t8*acl1*t13+0.346168885877477D2*t1
     #3+0.51762655480781D2*t3*theta
        t32 = t10*t3*t2
        t37 = t3**2
        t40 = t8**2
        t45 = t10**2
        t50 = als2(3,1)
        t54 = als1(4,2)
        t57 = t50*t3
        t59 = als2(4,2)
        t63 = t6*t3
        t65 = -0.183333333333333D2*t32+0.583333333333333D0*t3*t8*theta+2
     #.D0*t37*theta+0.1875D0*t2*t10*t40-2.D0*t45*theta*acl1+4.D0*acl1*t3
     #2+0.24D2*t50*acl1*t13-0.180000000000001D2*t54*t3-0.15079644737231D
     #3*t57-0.240000000000001D2*t59*t3+0.9D1*t54-0.236870505626145D3*t63
        t67 = t6*acl1
        t72 = als1(3,1)
        t78 = als1(4,1)
        t92 = -0.12D2*theta*t67*t13-0.418879020478638D2*t14+0.1466666666
     #66667D2*theta*t72*t3-0.16D2*t72*t13-0.6D1*t78*t13-0.10666666666666
     #7D2*t50*t13+0.464863899327028D2*acl1*t13-0.733333333333334D1*theta
     #*t72+0.266666666666667D1*t8*t6+0.666666666666667D0*t17*t8+0.12D2*t
     #59
        t103 = als3(4,1)
        t106 = alslsc1
        t109 = als2(3,0)
        t114 = als2(4,1)
        t121 = -0.133333333333333D2*theta*t50-0.533333333333335D1*t8*t63
     #-0.133333333333334D1*t17*t8*t3+0.837758040957279D2*theta*t63+0.753
     #982236861547D2*t50+0.15D1*t103*t13+0.12D2*t106*t13-0.1884955592153
     #87D2*t109*t13-0.335103216382912D2*t6*t13-0.6D1*t114*t13+0.75398223
     #6861549D2*t67*t13+0.266666666666668D2*theta*t57
        t123 = t45**2
        mer = 1/t2/t123/t10*(t30+t65+t92+t121)
        mei = 0
      endif
      mer=-mer
      mei=-mei
      return
      end

C =============================
      subroutine smevirtacexp(theta,mer,mei)
      implicit none
      doubleprecision theta,mer,mei

      doubleprecision Nc,tt
      doubleprecision t10
      doubleprecision t11
      doubleprecision t12
      doubleprecision t2
      doubleprecision t3
      doubleprecision t4
      doubleprecision t7
      parameter( Nc=3d0 )

C      write(6,*)'expanded form'
        t2 = 1/Nc
        t3 = log(theta)
        t4 = t3*t2
        t7 = t3*Nc
        t10 = theta**2
        t11 = t10**2
        t12 = t11**2
        mer = t12*t11*(0.510011331607018D-6*Nc-0.31822478912426D-5*t
     #4-0.4245798742672295D-6*t2+0.31822478912426D-5*t7)+t12*t10*(0.1796
     #875881310792D-5*Nc-0.304425145694987D-4*t4-0.3501098197173176D-6*t
     #2+0.304425145694987D-4*t7)+t12*(-0.2298363930308375D-4*Nc-0.278980
     #278980279D-3*t4+0.4438482042648709D-4*t2+0.278980278980279D-3*t7)+
     #t11*t10*(-0.7160073906105652D-3*Nc-0.2328042328042328D-2*t4+0.2328
     #042328042328D-2*t7+0.9596875787351978D-3*t2)+t11*(-0.1214947089947
     #09D-1*Nc-0.1587301587301587D-1*t4+0.135163139329806D-1*t2+0.158730
     #1587301587D-1*t7)+t10*(0.1342592592592593D0*t2-0.1490740740740741D
     #0*Nc-0.6666666666666667D-1*t4+0.6666666666666667D-1*t7)+0.75D0*t2-
     #0.1083333333333333D1*Nc
        mei=0d0
        return
      end

