C     ------------------------------------------------------------------
C     JET DEFINITION
C     ------------------------------------------------------------------
      double precision JetDefPtMin, JetDefEtaMax, JetDefConeSize, 
     &     UseSISCone
      COMMON/jetdef/JetDefPtMin, JetDefEtaMax, JetDefConeSize, 
     &     UseSISCone
      
C     ------------------------------------------------------------------
C     CUT CONTROL
C     ------------------------------------------------------------------
      double precision CutHardLeptPtMin, HardLeptPtMin,
     .     CutHardLeptPtMax,
     .     HardLeptPtMax, CutSoftLeptPtMin, SoftLeptPtMin, 
     .     CutSoftLeptPtMax, SoftLeptPtMax, CutHardLeptEta,
     .     HardLeptEtaMax, CutSoftLeptEta, SoftLeptEtaMax,
     .     CutIsolation, IsolationCone, Isolation, CutJetVeto,
     .     JetVetoPtMax, JetVetoEtaMax, JetConeSize, CutMassV1,
     .     MinMassV1, MaxMassV1, CutMassV2, MinMassV2, MaxMassV2,
     .     CutHiggsPt, HiggsPtMin, HiggsPtMax, CutVB1Pt, VB1PtMin,
     .     VB1PtMax, CutVB1Eta, VB1EtaMax, VB1EtaMin, CutVB2Pt, 
     .     VB2PtMin,
     .     VB2PtMax, CutVB2Eta, VB2EtaMax, VB2EtaMin, CutHiggsEta, 
     .     HiggsEtaMax, HiggsEtaMin,
     .     CutPhiLL, PhiLLMin, PhiLLMax, CutMissPt, MissPtMin,
     .     MissPtMax, CutInvMass, InvMassMin, InvMassMax ,CutTevVeto, 
     .     TevJetOnePtMax, TevJetTwoPtMax, CutSumPt, SumPtMin, SumPtMax,
     .     CutNumVeto, CutSpecMet, SpecMetMin, TriggerCut, TriggerPt,
     .     TriggerEta,
     .     all_leptons_maximum_y,cut_on_rapidity_of_all_leptons,
     .     all_leptons_minimum_pt,cut_on_pt_of_all_leptons 
      INTEGER maxNumJets

      
      COMMON/cutcontrol/CutHardLeptPtMin,HardLeptPtMin,CutHardLeptPtMax,
     .     HardLeptPtMax, CutSoftLeptPtMin, SoftLeptPtMin, 
     .     CutSoftLeptPtMax, SoftLeptPtMax, CutHardLeptEta,
     .     HardLeptEtaMax, CutSoftLeptEta, SoftLeptEtaMax,
     .     CutIsolation, IsolationCone, Isolation, CutJetVeto,
     .     JetVetoPtMax, JetVetoEtaMax, JetConeSize, CutMassV1,
     .     MinMassV1, MaxMassV1, CutMassV2, MinMassV2, MaxMassV2,
     .     CutHiggsPt, HiggsPtMin, HiggsPtMax, CutVB1Pt, VB1PtMin,
     .     VB1PtMax, CutVB1Eta, VB1EtaMax, VB1EtaMin, CutVB2Pt, 
     .     VB2PtMin,
     .     VB2PtMax, CutVB2Eta, VB2EtaMax, VB2EtaMin, CutHiggsEta, 
     .     HiggsEtaMax, HiggsEtaMin,
     .     CutPhiLL,PhiLLMin, PhiLLMax, CutMissPt, MissPtMin, MissPtMax,
     .     CutInvMass,InvMassMin,InvMassMax,CutTevVeto,TevJetOnePtMax,
     .     TevJetTwoPtMax, CutSumPt, SumPtMin, SumPtMax,
     .     CutNumVeto, CutSpecMet, SpecMetMin, TriggerCut, TriggerPt,
     .     TriggerEta, maxNumJets,
     .     all_leptons_maximum_y,cut_on_rapidity_of_all_leptons,
     .     all_leptons_minimum_pt,cut_on_pt_of_all_leptons


C=====================GAMMA GAMMA CUT CONTROL =================
      double precision CutPhotBasic,CutPhotIsol
      double precision ptg1m,ptg2m,etagM
      double precision PhotIsolationCone,PhotETmax
      double precision ystmin, ystmax, ptmmin, ptmmax
      double precision ystcut, ptmcut, brarat
      double precision ptsoftcut, ptsoftmin
      double precision CutPhotEtaHigh,EtaDiff_min,EtaDiff_max
      COMMON/ggcutcontrol/CutPhotBasic,ptg1m,ptg2m,etagM,CutPhotIsol,
     $     PhotIsolationCone,PhotETmax,ystmin, ystmax, ptmmin, ptmmax,
     $     ystcut, ptmcut, brarat,ptsoftcut,ptsoftmin,
     $     CutPhotEtaHigh,EtaDiff_min,EtaDiff_max
C================================================================
