      double complex function MWWZZlnln(GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45)
      implicit none
      double precision GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45

      double complex CV1
      double complex CV2
      double complex CA2
      double complex LambdaZ
      double complex LambdaW
      double complex gweak
      double complex cosW,sinW
      double complex v
      double complex CA1
      double complex tt1
      double complex tt2
      double complex tt3
      double complex tt4
      double complex tt5
      double complex tt6
      double complex tt7
      double complex tt8
      double complex tt9
      double complex tt10
      double complex tt11
      double complex tt12
      double complex tt13
      double complex tt14
      double complex tt15,tt16,tt17,tt18,tt19,tt20,tt21,tt22,tt23
      double complex numerator,denominator
      double complex ImagOne,One
      double precision Pi
      parameter(Pi=3.14159265358979d0)

      One = dcmplx(1d0,0d0)
      ImagOne = dcmplx(0d0,1d0)
      cosW=mW/mZ
      sinW=zsqrt(1d0-cosW**2)
      v=One/zsqrt(zsqrt(2d0*One)*Gf*One)
      LambdaW = 1d0/v
      LambdaZ = 1d0/v
      gweak = zsqrt(zsqrt(16*mW**4*GF**2/Pi**3*One))
      CA1 = dcmplx(1d0,0d0)
      CA2 = dcmplx(-1d0,0d0)
      CV1 = dcmplx(1d0,0d0)
      CV2 = -1d0-4d0*(-1d0)*sinW**2
      MWWZZlnln = dcmplx(0d0,0d0)

      numerator=1d0
      tt1 = -1
      numerator=numerator*tt1
      tt2 = mZ ** 2
      numerator=numerator*tt2
      tt3 = s24
      numerator=numerator*tt3
      tt4 = s35
      numerator=numerator*tt4
      tt5 = gweak ** 4
      numerator=numerator*tt5
      tt6 = cosW ** 2
      numerator=numerator*tt6
      tt7 = mW ** 2
      numerator=numerator*tt7
      tt8 = -2 * mW ** 2 * s45 + mW ** 4 + s45 ** 2 + mW ** 2 * GammaW *
     #* 2
      numerator=numerator*tt8
      tt9 = mW ** 4 + s23 ** 2 + mW ** 2 * GammaW ** 2 - 2 * mW ** 2 * s
     #23
      numerator=numerator*tt9
      tt10 = mZ ** 4 - 2 * mZ ** 2 * s34 + mZ ** 2 * GammaZ ** 2 + s34 *
     #* 2
      numerator=numerator*tt10
      tt11 = mZ ** 4 - 2 * mZ ** 2 * s25 + mZ ** 2 * GammaZ ** 2 + s25 *
     #* 2
      numerator=numerator*tt11
      tt12 = mZ ** 4 * mW ** 4 + mZ ** 2 * s25 * s23 * mW ** 2 - mZ ** 2
     # * s34 * s23 * s45 + mZ ** 2 * s34 * mW ** 2 * s45 - s34 * s25 * m
     #W ** 2 * GammaW ** 2 - mZ ** 2 * GammaZ ** 2 * s23 * s45 + mZ ** 2
     # * GammaZ ** 2 * mW ** 2 * s45 + s34 * s25 * s23 * s45 - s34 * s25
     # * mW ** 2 * s45 - mZ ** 2 * s25 * s23 * s45 + mZ ** 2 * s25 * mW 
     #** 2 * s45 + mZ ** 2 * s34 * mW ** 2 * GammaW ** 2 + s25 * GammaZ 
     #* mZ * s23 * mW * GammaW - 2 * GammaZ * mZ * s34 * mW ** 3 * Gamma
     #W - 2 * mZ ** 3 * GammaZ * mW * GammaW * s45 - 2 * s25 * GammaZ * 
     #mZ * mW ** 3 * GammaW + GammaZ * mZ * s34 * mW * GammaW * s45 - 2 
     #* mZ ** 3 * GammaZ * s23 * mW * GammaW + s25 * GammaZ * mZ * mW * 
     #GammaW * s45 + mZ ** 2 * s34 * s23 * mW ** 2 + 4 * mZ ** 3 * Gamma
     #Z * mW ** 3 * GammaW + mZ ** 2 * GammaZ ** 2 * s23 * mW ** 2 - s34
     # * s25 * s23 * mW ** 2 - mZ ** 2 * s34 * mW ** 4 - mZ ** 4 * s23 *
     # mW ** 2 - mZ ** 2 * GammaZ ** 2 * mW ** 4 + s34 * s25 * mW ** 4 -
     # mZ ** 2 * s25 * mW ** 4 + mZ ** 4 * s23 * s45 - mZ ** 4 * mW ** 2
     # * s45 - mZ ** 4 * mW ** 2 * GammaW ** 2 + GammaZ * mZ * s34 * s23
     # * mW * GammaW + mZ ** 2 * GammaZ ** 2 * mW ** 2 * GammaW ** 2 + m
     #Z ** 2 * s25 * mW ** 2 * GammaW ** 2
      numerator=numerator*tt12
      tt13 = CA2 + CV2
      numerator=numerator*tt13
      tt14 = CV1 + CA1
      numerator=numerator*tt14
      tt15 = LambdaW
      numerator=numerator*tt15
      tt16 = LambdaZ
      numerator=numerator*tt16
      tt17 = One
      numerator=numerator*tt17

      denominator=1d0
      tt18 = cosW ** 4
      denominator=denominator*tt18
      tt19 = (-2 * mW ** 2 * s45 + mW ** 4 + s45 ** 2 + mW ** 2 * GammaW
     # ** 2) ** 2
      denominator=denominator*tt19
      tt20 = (mW ** 4 + s23 ** 2 + mW ** 2 * GammaW ** 2 - 2 * mW ** 2 *
     # s23) ** 2
      denominator=denominator*tt20
      tt21 = (mZ ** 4 - 2 * mZ ** 2 * s34 + mZ ** 2 * GammaZ ** 2 + s34 
     #** 2) ** 2
      denominator=denominator*tt21
      tt22 = (mZ ** 4 - 2 * mZ ** 2 * s25 + mZ ** 2 * GammaZ ** 2 + s25 
     #** 2) ** 2
      denominator=denominator*tt22
      tt23 = One
      denominator=denominator*tt23

      MWWZZlnln = MWWZZlnln + numerator/denominator

      return
      end
