      double complex function MWWlnln(GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45)
      implicit none
      double precision GF,mW,GammaW,mZ,GammaZ,s23,s24,
     $     s25,s34,s35,s45

      double complex gweak
      double complex LambdaZ
      double complex LambdaW
      double complex tt1,tt2,tt3,tt4,tt5,tt6,tt7,tt8,tt9
      double complex tt10,tt11,tt12
      double complex cosW,sinW
      double complex v
      double complex numerator,denominator
      double complex ImagOne,One
      double precision Pi
      parameter(Pi=3.14159265358979d0)
 
      One = dcmplx(1d0,0d0)
      ImagOne = dcmplx(0d0,1d0)
      cosW=dcmplx(mW/mZ,0d0)
      sinW=zsqrt(1d0-cosW**2)
      v=One/zsqrt(zsqrt(2d0*One)*GF*One)
      LambdaW = 1d0/v
      LambdaZ = 1d0/v
      gweak = zsqrt(zsqrt(16*mW**4*GF**2/Pi**3*One))

      MWWlnln = dcmplx(0d0,0d0)

      numerator=1d0
      tt1 = 4
      numerator=numerator*tt1
      tt2 = s24
      numerator=numerator*tt2
      tt3 = s35
      numerator=numerator*tt3
      tt4 = gweak ** 4
      numerator=numerator*tt4
      tt5 = mW ** 4
      numerator=numerator*tt5
      tt6 = -2 * mW ** 2 * s45 + mW ** 4 + s45 ** 2 + mW ** 2 * GammaW *
     #* 2
      numerator=numerator*tt6
      tt7 = mW ** 4 + s23 ** 2 + mW ** 2 * GammaW ** 2 - 2 * mW ** 2 * s
     #23
      numerator=numerator*tt7
      tt8 = LambdaW ** 2
      numerator=numerator*tt8
      tt9 = One
      numerator=numerator*tt9

      denominator=1d0
      tt10 = (-2 * mW ** 2 * s45 + mW ** 4 + s45 ** 2 + mW ** 2 * GammaW
     # ** 2) ** 2
      denominator=denominator*tt10
      tt11 = (mW ** 4 + s23 ** 2 + mW ** 2 * GammaW ** 2 - 2 * mW ** 2 *
     # s23) ** 2
      denominator=denominator*tt11
      tt12 = One
      denominator=denominator*tt12

      MWWlnln = MWWlnln + numerator/denominator

      return
      end
