
      double precision function sli2(x)
      double precision fin,  x
      integer i
      fin=0
      do i=1, 13, 1
        fin = fin + (x**i)/(i**2)
      end do
      sli2=fin
      end
 
      double precision function sli3(x)
      double precision fin, x
      integer i
      fin=0
      do i=1, 13, 1
        fin = fin + (x**i)/(i**3)
      end do
      sli3=fin
      end
                                                                                                                                    
      double precision function ss12(x)
      double precision fin, x
      integer k,i,j
      fin=0
      do k=2, 13, 1
        do i=1, k, 1
          do j=1, k, 1
            if ((i+j).eq.(k)) then
              fin= fin+x**(i+j)/i/j/(i+j)/2.0d0
            end if
          end do
        end do
      end do
      ss12=fin
      end

      double precision function Li2(x)
CCC   uses double complex function bLi2(z) in hproSrc/utils/auxfuncs.f
      double precision x, pi, zeta2
      double precision sli2
      external sli2
      double complex bLi2
      external bLi2
      double complex ris
 
      pi=3.1415926535897932385D0
      zeta2=Pi**2/6.0D0
       
c$$$      if ((x.lt.(0.5)).or.(x.eq.(0.5)).AND.(x.gt.0)) then
c$$$        Li2=sli2(x)
c$$$      end if
c$$$       
c$$$      if ((x.gt.(0.5)).AND.(x.lt.1)) THEN
c$$$       Li2=-dlog(x)*dlog(1.0d0-x)+pi**2/6.0d0-sli2(1.0d0-x)
c$$$      end if
c$$$       
c$$$      if (x.lt.0) then
c$$$       Li2 = -0.5d0*dlog(1.0d0-x)**2-sli2(x/(x-1.0d0))
c$$$      end if
c$$$       
      if  (x.eq.1) then
        Li2=zeta2
      end if
     
      if (x.eq.0) then
        Li2=0.0D0
      end if

CCC   bLi2 is defined on the whole complex plane (except for cuts)
CCC    and has a faster converging series expansion
      ris=bLi2(dcmplx(x,0d0))
      Li2=dble(ris)

      return
      end

      double precision function Li3(x)
      double precision x, pi, zeta2, zeta3
      double precision sli2, sli3, ss12
      external sli2, sli3, ss12
 
      pi=3.1415926535897932385D0
      zeta2=Pi**2/6.0D0
      zeta3=1.2020569031595942854D0
      if ((x.lt.(0.5)).or.(x.eq.(0.5)).AND.(x.gt.0)) then
        Li3=sli3(x)
      end if
       
      if ((x.gt.(0.5)).AND.(x.lt.1)) THEN
       Li3=-ss12(1.0d0-x)-0.5D0*dlog(x)**2*dlog(1.0d0-x)-dlog(x)
     & *sli2(1.0d0-x)+zeta2*dlog(x)+zeta3
      end if
       
      if (x.lt.0) then
       Li3 = -sli3(x/(x-1))+ss12(x/(x-1.0d0))-dlog(1.0d0-x)
     & *sli2(x/(x-1.0d0))-1.0D0/6.0D0*dlog(1.0d0-x)**3
      end if
       
      if  (x.eq.1) then
        Li3=zeta3
      end if
      if (x.eq.0) then
        Li3=0.0D0
      end if
      end

      double precision function S12f(x)
      double precision x, pi, zeta2, zeta3
      double precision sli2, sli3, ss12
      external sli2, sli3, ss12
 
      pi=3.1415926535897932385D0
      zeta2=pi**2/6.0D0
      zeta3=1.2020569031595942854D0
      if ((x.lt.(0.5)).or.(x.eq.(0.5)).AND.(x.gt.0)) then
        S12f=ss12(x)
      end if
       
      if ((x.gt.(0.5)).AND.(x.lt.1)) THEN
       S12f=-sli3(1.0d0-x)+0.5D0*dlog(x)*dlog(1.0d0-x)**2
     &      +dlog(1.0d0-x)*sli2(1.0d0-x)+zeta3
 
      end if
      if (x.lt.0) then
       S12f=ss12(x/(x-1.0d0))+1.0D0/6.0D0*dlog(1.0d0-x)**3
      end if
      if  (x.eq.1) then
        S12f=zeta3
      end if
      if (x.eq.0) then
        S12f=0.0D0
      end if
      end

